import pyddl
import sys
import numpy as np

n = 100

pyddl.init()

# array 1
n1 = 6

initial_values1 = [x for x in range(n1)]

arr1 = np.array(initial_values1, dtype=np.float32)

res1, buf1 = pyddl.malloc(64, n1 * 4)

pyddl.memcpy_host_to_device(buf1, arr1)

# array 2

n2 = 13

initial_values2 = [x * 2 for x in range(n2)]

arr2 = np.array(initial_values2, dtype=np.float32)

res2, buf2 = pyddl.malloc(64, n2 * 4)

pyddl.memcpy_host_to_device(buf2, arr2)

# array 3

n3 = 22

initial_values3 = [x * 3 for x in range(n3)]

arr3 = np.array(initial_values3, dtype=np.float32)

res3, buf3 = pyddl.malloc(64, n3 * 4)

pyddl.memcpy_host_to_device(buf3, arr3)

pyddl.memsync()

# destination

dest = np.array([0 for x in range(n1+n2+n3)], dtype=np.float32)

res3, buf_dest = pyddl.malloc(64, (n1 + n2 + n3) * 4)

pyddl.memcpy_gather(buf_dest, np.array([buf1, buf2, buf3], dtype=np.uint64), np.array([n1*4,n2*4,n3*4], dtype=np.uint64), 3 )

pyddl.memsync()

pyddl.memcpy_device_to_host(dest, buf_dest)

pyddl.memsync()

pyddl.free(buf1)
pyddl.free(buf2)
pyddl.free(buf3)
pyddl.free(buf_dest)

# Verify that the memcpy_gather produced the correct result
result = np.array_equal(np.array(initial_values1 + initial_values2 + initial_values3, dtype=np.float32), dest)

pyddl.finalize()

if result:
    sys.exit(0)
else:
    sys.exit(1)

